local gfx <const> = playdate.graphics

local focusPriority = {}

cameraPanSystem = filteredSystem({ focusPriority = T.number, position = T.XyPair }, function(e, dt)
    if e.focusPriority >= focusPriority.priority then
        focusPriority.position = e.position
    end
end)

function cameraPanSystem:preProcess()
    focusPriority.priority = 0
    focusPriority.position = { x = 0, y = 0 }
end

function cameraPanSystem:postProcess()
    local panX = math.max(0, focusPriority.position.x - 200)
    local panY = math.min(0, focusPriority.position.y - 120)
    gfx.setDrawOffset(-panX, -panY)
end
