collisionResolution = filteredSystem({ collisionBetween = T.Collision }, function(e, _, system)
    local collidedInto, collider = e.collisionBetween[1], e.collisionBetween[2]
    local colliderTop = collidedInto.position.y

    if collidedInto.isSolid then
        -- Assumes impact from the top
        collider.position.y = colliderTop - collider.size.y
    end

    if collidedInto.canBounce and collider.canBeBounced then
        collider.velocity.x = collider.velocity.x + collidedInto.canBounce.flat.x + collider.canBeBounced.flat.x

        collider.velocity.x = collider.velocity.x * collidedInto.canBounce.mult.x * collider.canBeBounced.mult.x

        -- abs() makes sure we always push upward
        collider.velocity.y = math.abs(collider.velocity.y)
            + collidedInto.canBounce.flat.y
            + collider.canBeBounced.flat.y

        collider.velocity.y = collider.velocity.y * collidedInto.canBounce.mult.y * collider.canBeBounced.mult.y
    end

    if collider.stopMovingOnCollision then
        print("stopMovingOnCollision!")
        collider.velocity = nil
        collider.canCollideWith = nil
        system.world:addEntity(collider)
    end

    if collidedInto.score then
        Score:add(collidedInto.score)
    end

    if collidedInto.expireAfterCollision then
        system.world:removeEntity(collidedInto)
    end

    if collidedInto.collectable and collider.collectables then
        collider.collectables[#collider.collectables + 1] = collidedInto.collectable
    end

    system.world:removeEntity(e)
end)
